// Copyright 2017 FoxyUtils ehf. All rights reserved.
//
// DO NOT EDIT: generated by gooxml ECMA-376 generator
//
// Use of this source code is governed by the terms of the Affero GNU General
// Public License version 3.0 as published by the Free Software Foundation and
// appearing in the file LICENSE included in the packaging of this file. A
// commercial license can be purchased via https://unidoc.io website.

package sml

import (
	"encoding/xml"
	"fmt"

	"github.com/unidoc/unioffice"
)

type CT_ExternalReferences struct {
	// External Reference
	ExternalReference []*CT_ExternalReference
}

func NewCT_ExternalReferences() *CT_ExternalReferences {
	ret := &CT_ExternalReferences{}
	return ret
}

func (m *CT_ExternalReferences) MarshalXML(e *xml.Encoder, start xml.StartElement) error {
	e.EncodeToken(start)
	seexternalReference := xml.StartElement{Name: xml.Name{Local: "ma:externalReference"}}
	for _, c := range m.ExternalReference {
		e.EncodeElement(c, seexternalReference)
	}
	e.EncodeToken(xml.EndElement{Name: start.Name})
	return nil
}

func (m *CT_ExternalReferences) UnmarshalXML(d *xml.Decoder, start xml.StartElement) error {
	// initialize to default
lCT_ExternalReferences:
	for {
		tok, err := d.Token()
		if err != nil {
			return err
		}
		switch el := tok.(type) {
		case xml.StartElement:
			switch el.Name {
			case xml.Name{Space: "http://schemas.openxmlformats.org/spreadsheetml/2006/main", Local: "externalReference"},
				xml.Name{Space: "http://purl.oclc.org/ooxml/spreadsheetml/main", Local: "externalReference"}:
				tmp := NewCT_ExternalReference()
				if err := d.DecodeElement(tmp, &el); err != nil {
					return err
				}
				m.ExternalReference = append(m.ExternalReference, tmp)
			default:
				unioffice.Log("skipping unsupported element on CT_ExternalReferences %v", el.Name)
				if err := d.Skip(); err != nil {
					return err
				}
			}
		case xml.EndElement:
			break lCT_ExternalReferences
		case xml.CharData:
		}
	}
	return nil
}

// Validate validates the CT_ExternalReferences and its children
func (m *CT_ExternalReferences) Validate() error {
	return m.ValidateWithPath("CT_ExternalReferences")
}

// ValidateWithPath validates the CT_ExternalReferences and its children, prefixing error messages with path
func (m *CT_ExternalReferences) ValidateWithPath(path string) error {
	for i, v := range m.ExternalReference {
		if err := v.ValidateWithPath(fmt.Sprintf("%s/ExternalReference[%d]", path, i)); err != nil {
			return err
		}
	}
	return nil
}
