// Copyright 2017 FoxyUtils ehf. All rights reserved.
//
// DO NOT EDIT: generated by gooxml ECMA-376 generator
//
// Use of this source code is governed by the terms of the Affero GNU General
// Public License version 3.0 as published by the Free Software Foundation and
// appearing in the file LICENSE included in the packaging of this file. A
// commercial license can be purchased via https://unidoc.io website.

package sml

import (
	"encoding/xml"
	"fmt"
	"strconv"

	"github.com/unidoc/unioffice"
)

type CT_WebPublishObjects struct {
	// Count
	CountAttr *uint32
	// Web Publishing Object
	WebPublishObject []*CT_WebPublishObject
}

func NewCT_WebPublishObjects() *CT_WebPublishObjects {
	ret := &CT_WebPublishObjects{}
	return ret
}

func (m *CT_WebPublishObjects) MarshalXML(e *xml.Encoder, start xml.StartElement) error {
	if m.CountAttr != nil {
		start.Attr = append(start.Attr, xml.Attr{Name: xml.Name{Local: "count"},
			Value: fmt.Sprintf("%v", *m.CountAttr)})
	}
	e.EncodeToken(start)
	sewebPublishObject := xml.StartElement{Name: xml.Name{Local: "ma:webPublishObject"}}
	for _, c := range m.WebPublishObject {
		e.EncodeElement(c, sewebPublishObject)
	}
	e.EncodeToken(xml.EndElement{Name: start.Name})
	return nil
}

func (m *CT_WebPublishObjects) UnmarshalXML(d *xml.Decoder, start xml.StartElement) error {
	// initialize to default
	for _, attr := range start.Attr {
		if attr.Name.Local == "count" {
			parsed, err := strconv.ParseUint(attr.Value, 10, 32)
			if err != nil {
				return err
			}
			pt := uint32(parsed)
			m.CountAttr = &pt
			continue
		}
	}
lCT_WebPublishObjects:
	for {
		tok, err := d.Token()
		if err != nil {
			return err
		}
		switch el := tok.(type) {
		case xml.StartElement:
			switch el.Name {
			case xml.Name{Space: "http://schemas.openxmlformats.org/spreadsheetml/2006/main", Local: "webPublishObject"},
				xml.Name{Space: "http://purl.oclc.org/ooxml/spreadsheetml/main", Local: "webPublishObject"}:
				tmp := NewCT_WebPublishObject()
				if err := d.DecodeElement(tmp, &el); err != nil {
					return err
				}
				m.WebPublishObject = append(m.WebPublishObject, tmp)
			default:
				unioffice.Log("skipping unsupported element on CT_WebPublishObjects %v", el.Name)
				if err := d.Skip(); err != nil {
					return err
				}
			}
		case xml.EndElement:
			break lCT_WebPublishObjects
		case xml.CharData:
		}
	}
	return nil
}

// Validate validates the CT_WebPublishObjects and its children
func (m *CT_WebPublishObjects) Validate() error {
	return m.ValidateWithPath("CT_WebPublishObjects")
}

// ValidateWithPath validates the CT_WebPublishObjects and its children, prefixing error messages with path
func (m *CT_WebPublishObjects) ValidateWithPath(path string) error {
	for i, v := range m.WebPublishObject {
		if err := v.ValidateWithPath(fmt.Sprintf("%s/WebPublishObject[%d]", path, i)); err != nil {
			return err
		}
	}
	return nil
}
